<?php

/**
 * Carerix Wordpress Plugin
 *
 * @category template manager
 * @author Bogdan Ivanov
 * @copyright Copyright (c) 2013 Carerix.com (http://www.carerix.com)
 * @link http://www.carerix.com
 * @since Aug 26, 2013 10:05:48 AM
 * @version $Rev$
 */

/**
 * Admin_Settings class
 * Used to ....
 */
class Admin_Googleforjobs extends WP_Page {

    protected $interfacer = null;

	/** @noinspection PhpMissingParentConstructorInspection */
	public function __construct() {
        $this->interfacer = WP_Interfacer::getInstance();
    }

    public function getCapability() {
        return WP_Constants::CAPABILITY_ADMIN;
    }

    public function getMenuSlug() {
        return 'carerix_googleforjobs_page';
    }

    public function getMenuTitle() {
        return 'Google for jobs';
    }

    public function getPageTitle() {
        return 'Google for jobs';
    }

    public function page() {
        $input_data = filter_input_array(INPUT_POST, FILTER_SANITIZE_STRING);

	    $gfj_status = Environment_Settings::getGoogleforjobsStatus();
	    $gfj_org    = Environment_Settings::getGoogleforjobsOrganization();
	    $gfj_logo   = Environment_Settings::getGoogleforjobsLogoId();

		if (isset($input_data[Environment_Settings::KEY_GOOGLEFORJOBS_ENABLED])) {
			$gfj_status = $input_data[Environment_Settings::KEY_GOOGLEFORJOBS_ENABLED];
        }

		if (isset($input_data[Environment_Settings::KEY_GOOGLEFORJOBS_ORGANIZATION])) {
			$gfj_org = $input_data[Environment_Settings::KEY_GOOGLEFORJOBS_ORGANIZATION];
        }

		if (isset($input_data[Environment_Settings::KEY_GOOGLEFORJOBS_LOGO])) {
			$gfj_logo = $input_data[Environment_Settings::KEY_GOOGLEFORJOBS_LOGO];
        }


		if ($input_data != null && wp_verify_nonce($input_data['_carerix_nonce_field'], 'googleforjobs')) {
			if ( !isset($input_data[Environment_Settings::KEY_GOOGLEFORJOBS_ENABLED]) ) {
				// $input_data[Environment_Settings::KEY_GOOGLEFORJOBS_ENABLED] = "off";
				$gfj_status = "off";
			}
			Environment_Settings::setGoogleforjobsStatus($gfj_status);
        }

		if ($input_data != null && wp_verify_nonce($input_data['_carerix_nonce_field'], 'googleforjobs')) {
			Environment_Settings::setGoogleforjobsOrganization($gfj_org);
        }

		if ($input_data != null && wp_verify_nonce($input_data['_carerix_nonce_field'], 'googleforjobs')) {
			Environment_Settings::setGoogleforjobsLogo($gfj_logo);
        }


	    $data = array(
	        Environment_Settings::KEY_GOOGLEFORJOBS_ENABLED => $gfj_status,
	        Environment_Settings::KEY_GOOGLEFORJOBS_ORGANIZATION => $gfj_org,
	        Environment_Settings::KEY_GOOGLEFORJOBS_LOGO => $gfj_logo,
        );


        $template = new Utils_Template('admin/forms/googleforjobs_settings'); // wp-content/plugins/CxWordpress/templates/admin/forms/conversion_tracking.php
        $template->with($data)->display();
    }

}