<?php

/**
 * Carerix Wordpress Plugin
 *
 * @category settings
 * @author Bogdan Ivanov
 * @copyright Copyright (c) 2013 Carerix.com (http://www.carerix.com)
 * @link http://www.carerix.com
 * @since Aug 29, 2013 1:08:16 PM
 * @version $Rev$
 */

/**
 * Job class
 * Used to ....
 */
class Entity_Cron_Company extends Entity_Cron {
	
	public function getUrl() {
		$companiesUrl = Environment_Installation::get_people_feed();
		if(@$this->sourceData['settings']['feed'])
		{
			$companiesUrl .= '?'.$this->sourceData['settings']['feed'];
		}
		
		return $companiesUrl;
	}

	public function process($data)
	{
        Utils_Cache::cleanEnvironment();
		$items = $data->channel->item;
		$itemsTable = $this->getArrayOfItems($items);
		
		$listOfFragments = array();
		
		/**
		 * for each item in the table,
		 * create a writer,
		 * write,
		 * collect a fragment
		 */
		foreach($itemsTable as $item)
		{
			$company = new Entity_Writer_Company($item);
			$id = $company->write();
			array_push($listOfFragments, $company->getFragment($id));
            $this->interfacer->entity_set_property( $id, 
													'source', 
													$this->sourceData['id']);
		}
		
		/**
		 * launch the collector for all the items from this source.
		 * creates a page in wordpress
		 */
		$collector = new Entity_Writer_Collector($this->sourceData['name'], 
												 $this->sourceData['type'], 
												 $this->sourceData['id'], 
												 $listOfFragments,
                                                 @$this->sourceData['settings']['introtext']);
		$collector->write();
	}
	
	/**
	 * Formats the retrieved xml into a list of tables
	 * 
	 * 
	 * @param SimpleXML $data
	 * @return array
	 */
	private function getArrayOfItems($data)
	{
		$items = array();
		
		$collectors = array('id', 'name', 'companyInformation', 'visitAddress', 
			'visitPostalCode', 'phoneNumber', 'emailAddress', 'url');
		
		foreach($data as $item)
		{
			$newItem = array();
			
			foreach($collectors as $collector)
			{
                
                
				if(isset($item->$collector))
				{
                    $name_collector = preg_replace('/\s+/u'  , ' | ',trim(strip_tags((string)$item->$collector)));
                    $name_collector = htmlentities($name_collector, null, 'utf-8');
                    $name_collector = str_replace('&nbsp;', '', $name_collector);
                    $name_collector = str_replace('&#160;', '', $name_collector); 
                    if(strlen($name_collector) == 0) continue;
                    
					switch($collector)
					{
						case 'users':
							$newItem[$collector] = (array)$item->$collector;
							
							if(   isset($newItem[$collector]['user']) 
							   && $newItem[$collector]['user'] !== NULL)
							{
								if(is_string($newItem[$collector]['user'])) 
								{
									continue;
								}
								
								if(is_object($newItem[$collector]['user']))
								{
									$newItem[$collector]['user'] = array(
										$newItem[$collector]['user']
									);
								}
							}
							break;
						default:
							$newItem[$collector] = (string)$item->$collector;
					}
				}
			}
			
			if(!empty($newItem)) array_push ($items, $newItem);
		}
		
		return $items;
	}
}